﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using System.ServiceModel;
using System.IO;
using System.Xml.Serialization;

namespace MvcApp.Controllers
{

	public static class Utils {
		public static string SerializeObject<T>(this T toSerialize)
		{
			XmlSerializer xmlSerializer = new XmlSerializer(toSerialize.GetType());

			using(StringWriter textWriter = new StringWriter())
			{
				xmlSerializer.Serialize(textWriter, toSerialize);
				return textWriter.ToString();
			}
		}
	}

	public class DrugSearchController : Controller
	{
		private BasicHttpBinding getBinding() {
			return new BasicHttpBinding{
				OpenTimeout = TimeSpan.MaxValue,
				CloseTimeout = TimeSpan.MaxValue,
				SendTimeout = TimeSpan.MaxValue,
				ReceiveTimeout = TimeSpan.MaxValue,
				ReaderQuotas = { MaxStringContentLength = 2147483647, MaxBytesPerRead = 2147483647, MaxArrayLength = 2147483647 },
				MaxBufferSize = 6553500,
				MaxReceivedMessageSize = 6553500
			};
		}

		private Service.MyServiceClient getClient() {
			var binding = getBinding ();
			var address = new EndpointAddress ("http://test.m.lekseek.com:33222");
			return new Service.MyServiceClient (binding, address);
		}

		// List categories.
		public ContentResult Search(String pattern) {
			var client = getClient ();
			var clientAuthCode = "exampleKey";
			var drugList = client.getDrugListByName(clientAuthCode, pattern);
			return Content(Utils.SerializeObject (drugList), "text/xml");
		}

		public ContentResult DrugDescr(int id) {
			var client = getClient ();
			var clientAuthCode = "exampleKey";
			var ids = new List<int> ();
			ids.Add (id);
			var drugDescr = client.getDrugDescrsByPackageIds(clientAuthCode, ids);
			return Content(Utils.SerializeObject (drugDescr), "text/xml");
		}

		public ContentResult DrugSubst(int id) {
			var client = getClient ();
			var clientAuthCode = "exampleKey";
			var ids = new List<int> ();
			ids.Add (id);
			var drugDescr = client.getSubstByPackageIds(clientAuthCode, ids);
			return Content(Utils.SerializeObject (drugDescr), "text/xml");
		}
	}
}
