﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace MvcApp
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterRoutes(RouteCollection routes) {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

			routes.MapRoute(
				"Search"
				, "Search/{pattern}"
				, new { Controller = "DrugSearch", action = "Search", pattern="" }
				, new [] { "WebApp.Controllers" }
			);

			routes.MapRoute(
				"DrugDescr"
				, "DrugDescr/{id}"
				, new { Controller = "DrugSearch", action = "DrugDescr", id=0 }
				, new [] { "WebApp.Controllers" }
			);

			routes.MapRoute(
				"DrugSubst"
				, "DrugSubst/{id}"
				, new { Controller = "DrugSearch", action = "DrugSubst", id=0 }
				, new [] { "WebApp.Controllers" }
			);

			routes.MapRoute(
				"Default"
				, "{*src}"
				, new { Controller = "Home", action = "Index"}
				, new [] { "WebApp.Controllers" }
			);
        }

        protected void Application_Start() {
            RegisterRoutes(RouteTable.Routes);
        }
    }
}