﻿using System;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Collections.Generic;

namespace Client
{
	public class MyServiceClient : ClientBase<Service.IWcfService>, Service.IWcfService
	{
		public MyServiceClient (Binding binding, EndpointAddress address) : base (binding, address)
		{
		}

		public string getVersion (string key)
		{
			return Channel.getVersion(key);
		}

		public List<Service.Drug> getDrugFormsByDate(string key)
		{ 
			return Channel.getDrugFormsByDate (key);
		}

		public Service.Status getStatus(string key)
		{
			return Channel.getStatus (key);
		}

		public List<Service.Subst> getSubstAll (string key)
		{
			return Channel.getSubstAll (key);
		}

		public List<Service.Payment> getDiseasePayments(string key)
		{
			return Channel.getDiseasePayments (key);
		}

		public List<Service.Disease> getDiseases(string key)
		{
			return Channel.getDiseases (key);
		}

		public List<Service.DrugPicture> getDrugPicturesByPackageIds(string key, List<int> ids)
		{
			return Channel.getDrugPicturesByPackageIds (key, ids);
		}

		public List<Service.PackageSubst> getSubstByPackageIds(string key, List<int> ids)
		{
			return Channel.getSubstByPackageIds (key, ids);
		}

		public List<Service.Prescription> getPrescriptions(string key)
		{
			return Channel.getPrescriptions (key);
		}

		public List<Service.Company> getCompanyListByName(string key, string txt)
		{
			return Channel.getCompanyListByName (key, txt);
		}

		public List<Service.DrugForm> getDrugFormsByCompanyIds (string key, List<int> ids)
		{
			return Channel.getDrugFormsByCompanyIds (key, ids);
		}

		public List<Service.DrugDescr> getDrugDescrsByPackageIds (string key, List<int> ids)
		{
			return Channel.getDrugDescrsByPackageIds (key, ids);
		}
	}
}