Ext.define('MyApp.view.main.DrugInfo', {
    extend:'Ext.tab.Panel',
	xtype: 'drugInfo',
    width: 300,
    height: 500,
	id: 'DrugInfoPanel',
    items: [
        {
			y: 20,
            title: 'Opis leku',
			id: 'DrugInfoPanelDescr'
        },
        {
			y: 20,
            title: 'Substancje czynne',
			id: 'DrugInfoPanelSubst'
        }
    ],
});

Ext.define('MyApp.view.main.List', {
    extend: 'Ext.grid.Panel',
    xtype: 'mainlist',
    title: 'Lista leków',
    id : 'mainList',
    store: store,
    columns: [
        {text: "Id", width: 100, dataIndex: 'DrugId', sortable: true},
        {text: "Nazwa", width: 150, dataIndex: 'DrugName', sortable: true},
        {text: "Producent", width: 150, dataIndex: 'DrugCompanyName', sortable: true},
    ],
    width: 420,
    height: 500,
    listeners : {
    	itemclick: function(dv, record, item, index, e) {
			Ext.Ajax.request({
				url: '/DrugSubst/'+item.getElementsByTagName("td")[0].textContent,
				method: 'GET',
				success: function(response){
					var xml = new XMLSerializer().serializeToString(response.responseXML);
					var parser = new DOMParser();
					var xmlDoc = parser.parseFromString(xml, "application/xml");
					var res = Ext.DomQuery.select('ArrayOfPackageSubst/PackageSubst', xmlDoc);
					var substs = '<ul>';
					for(i=0;i<res.length;i++) {
						substs += '<li>' + Ext.DomQuery.selectValue('SubstName', res[i]) + '</li>';
					}
					substs += '</ul>';
					Ext.getCmp('DrugInfoPanelSubst').update(substs);
				}
			});
			
			Ext.Ajax.request({
				url: '/DrugDescr/'+item.getElementsByTagName("td")[0].textContent,
				method: 'GET',
				success: function(response){
					var xml = new XMLSerializer().serializeToString(response.responseXML);
					var parser = new DOMParser();
					var xmlDoc = parser.parseFromString(xml, "application/xml");
					var res = Ext.DomQuery.select('ArrayOfDrugDescr/DrugDescr', xmlDoc);
					var descr = Ext.DomQuery.selectValue('DrugHtml', res[0]);
					Ext.getCmp('DrugInfoPanelDescr').update(descr);
				}
			});
    	}
	}
});

Ext.define('MyApp.view.main.SearchBox', {
    extend: 'Ext.form.Panel',
    xtype: 'searchBox',
    title: 'Wyszukaj lek',
    height: 120,
    width: 300,
    bodyPadding: 10,
    defaultType: 'textfield',
    items: [
        {
            fieldLabel: 'Nazwa leku',
            name: 'searchPattern',
            id : 'searchPattern'
        }
    ],
    width: 750
});

Ext.define('MyApp.view.main.MainContainer', {
	extend : 'Ext.container.Container',
    layout:'absolute',
    xtype:'mainContainer',
    items: [{
        x: 0,
        y: 10,
        xtype:'searchBox'
    },{
        x: 350,
        y: 65,
        xtype: 'button',
        text : 'Szukaj',
	    listeners : {
	    	click: function() {
	        	store.getProxy().url = '/Search/'+Ext.getCmp('searchPattern').getValue();
	        	store.load();
	        }
	    }
    },{
        x: 0,
        y: 120,
        xtype:'mainlist'
    },{
        x: 450,
        y: 120,
        xtype:'drugInfo'
    }]
});


Ext.define('MyApp.view.main.Main', {
    extend: 'Ext.tab.Panel',
    xtype: 'app-main',

    requires: [
        'Ext.plugin.Viewport',
        'Ext.window.MessageBox',
        'MyApp.view.main.MainController',
        'MyApp.view.main.MainModel',
        'MyApp.view.main.List',
        'MyApp.view.main.MainContainer',
        'MyApp.view.main.SearchBox',
    ],

    controller: 'main',
    viewModel: 'main',

    ui: 'navigation',

    tabBarHeaderPosition: 1,
    titleRotation: 0,
    tabRotation: 0,

    header: {
        layout: {
            align: 'stretchmax'
        },
        title: {
            bind: {
                text: 'LeskeekApiDemo'
            },
            flex: 0
        },
        iconCls: 'fa-th-list'
    },

    tabBar: {
        flex: 1,
        layout: {
            align: 'stretch',
            overflowHandler: 'none'
        }
    },

    responsiveConfig: {
        tall: {
            headerPosition: 'top'
        },
        wide: {
            headerPosition: 'left'
        }
    },

    defaults: {
        bodyPadding: 20,
        tabConfig: {
            plugins: 'responsive',
            responsiveConfig: {
                wide: {
                    iconAlign: 'left',
                    textAlign: 'left'
                },
                tall: {
                    iconAlign: 'top',
                    textAlign: 'center',
                    width: 120
                }
            }
        }
    },

    items: [{
        title: 'Wyszukiwarka',
        iconCls: 'fa-home',
        items: [{
            xtype: 'mainContainer'
        }]
    }]
});
